## dtksystemsettings 1.0.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)

# If do't define version number, specify the version number
set(VERSION "1.0.0" CACHE STRING "define project version")

project(dtksystemsettings
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtksystemsettings
    DESCRIPTION "dtk library for systemsettings."
    VERSION ${VERSION}
)

add_subdirectory(dtklogin)
add_subdirectory(dtkpower)
add_subdirectory(dtkaccounts)

=== dtkaccounts/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)
# If do't define version number, specify the version number
set(VERSION "1.0.0" CACHE STRING "define project version")
set(BIN_NAME dtkaccounts)

project(${BIN_NAME}
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtksystemsettings
    DESCRIPTION "accounts DBus interface binding for Qt"
    VERSION ${VERSION})

# specify install dir
include(GNUInstallDirs)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--as-needed")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_CXX_FLAGS Release CACHE STRING "define CXXFLAGS")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
endif ()

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui DBus)

add_subdirectory(src)

set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")
find_package(Doxygen)
if (BUILD_DOCS AND DOXYGEN_FOUND)
    add_subdirectory(docs)
endif ()

# test
if (BUILD_TESTING)
   add_subdirectory(tests)
endif ()

# example
if (BUILD_EXAMPLE)
    add_subdirectory(example)
endif ()

# for pc file config
set(PC_LIBS_PRIVATE Qt${QT_VERSION_MAJOR}Core)
set(PC_REQ_PRIVATE)
set(PC_REQ_PUBLIC)

# config pkgconfig file
configure_file(misc/${BIN_NAME}.pc.in ${BIN_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
# config cmake file
configure_file(misc/${BIN_NAME}Config.cmake.in ${BIN_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${BIN_NAME})

# config qmake moudule file
set(DTK_MODULE ${BIN_NAME})
set(DTK_DEPS "core dbus")
set(QMKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")
configure_file(misc/qt_lib_${BIN_NAME}.pri.in qt_lib_${BIN_NAME}.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_${BIN_NAME}.pri DESTINATION "${QMKSPECS_INSTALL_DIR}")

=== dtklogin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)

# If do't define version number, specify the version number
set(VERSION "1.0.0" CACHE STRING "define project version")

set(BIN_NAME dtklogin)

project(${BIN_NAME}
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtksystemsettings
    DESCRIPTION "login1 DBus interfaces binding for Qt."
    VERSION ${VERSION})

include(GNUInstallDirs)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--as-needed")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_CXX_FLAGS Release CACHE STRING "define CXXFLAGS")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
endif ()

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui DBus)

add_subdirectory(src)
add_subdirectory(examples)

set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")
find_package(Doxygen)
if (BUILD_DOCS AND DOXYGEN_FOUND)
    add_subdirectory(docs)
endif ()

# test
if (BUILD_TESTING)
   add_subdirectory(tests)
endif ()

# for pc file config
set(PC_LIBS_PRIVATE Qt${QT_VERSION_MAJOR}Core)
set(PC_REQ_PRIVATE)
set(PC_REQ_PUBLIC)

# config pkgconfig file
configure_file(misc/${BIN_NAME}.pc.in ${BIN_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
# config cmake file
configure_file(misc/${BIN_NAME}Config.cmake.in ${BIN_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${BIN_NAME})

# config qmake moudule file
set(DTK_MODULE ${BIN_NAME})
set(DTK_DEPS "core dbus")
set(QMKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")
configure_file(misc/qt_lib_${BIN_NAME}.pri.in qt_lib_${BIN_NAME}.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_${BIN_NAME}.pri DESTINATION "${QMKSPECS_INSTALL_DIR}")

=== dtkpower/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)
# If do't define version number, specify the version number
set (VERSION "1.0.0" CACHE STRING "define project version")
set(BIN_NAME dtkpower)

project(dtkpower
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtksystemsettings
    DESCRIPTION "UPower DBus interfaces binding for Qt."
    VERSION ${VERSION})

# specify install dir
include(GNUInstallDirs)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--as-needed")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_CXX_FLAGS Release CACHE STRING "define CXXFLAGS")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
    set(BUILD_EXAMPLES ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
endif ()

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui DBus)

add_subdirectory(src)

set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")
find_package(Doxygen)
if (BUILD_DOCS AND DOXYGEN_FOUND)
    add_subdirectory(docs)
endif ()

# test
if (BUILD_TESTING)
    add_subdirectory(tests)
endif ()

# examples
if (BUILD_EXAMPLES)
    add_subdirectory(examples)
endif ()

# for pc file config
set(PC_LIBS_PRIVATE Qt${QT_VERSION_MAJOR}Core)
set(PC_REQ_PRIVATE)
set(PC_REQ_PUBLIC)

# config pkgconfig file
configure_file(misc/${BIN_NAME}.pc.in ${BIN_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
# config cmake file
configure_file(misc/${BIN_NAME}Config.cmake.in ${BIN_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${BIN_NAME})

# config qmake moudule file
set(DTK_MODULE ${BIN_NAME})
set(DTK_DEPS "core dbus")
set(QMKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")
configure_file(misc/qt_lib_${BIN_NAME}.pri.in qt_lib_${BIN_NAME}.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_${BIN_NAME}.pri DESTINATION "${QMKSPECS_INSTALL_DIR}")

=== dtkaccounts/docs/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc CACHE STRING "QCH install location")
set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dde.${CMAKE_PROJECT_NAME}")
set (DOXYGEN_QCH_FILE "${CMAKE_PROJECT_NAME}.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER ${CMAKE_PROJECT_NAME})
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-5/" CACHE STRING "Doxygen tag files")
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
set (DOXYGEN_PREDEFINED
    "\"DACCOUNTS_BEGIN_NAMESPACE=namespace Dtk::Accounts{\""
    "\"DACCOUNTS_END_NAMESPACE=}\""
    "\"DACCOUNTS_USE_NAMESPACE=using namespace Dtk::Accounts;\""
)

doxygen_add_docs (doxygen_dtkaccounts
    ${CMAKE_CURRENT_SOURCE_DIR}/../include
    ${CMAKE_CURRENT_SOURCE_DIR}/../docs
    ALL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/html/${CMAKE_PROJECT_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== dtkaccounts/example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE INCLUDE_FILES "../include/*.h")
set(LIB_NAME ${BIN_NAME})
set(BIN_NAME account_example)

add_executable(${BIN_NAME}
    ${INCLUDE_FILES}
    main.cpp
    demo.h
    demo.cpp
)

include_directories(../include)

target_include_directories(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
    ${LIB_NAME}
)

=== dtkaccounts/src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE INCLUDE_FILES "../include/*.h")
file(GLOB_RECURSE SRCS
    "./*.h"
    "./*.cpp"
)

add_library(${BIN_NAME} SHARED
    ${INCLUDE_FILES}
    ${SRCS}
)

include_directories(../include)

set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

target_include_directories(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
    -lcrypt
)

install(FILES ${INCLUDE_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BIN_NAME})
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== dtkaccounts/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME ut-${BIN_NAME})

find_package(GTest REQUIRED)
file(GLOB_RECURSE INCLUDE_FILES "../include/*.h")
file(GLOB_RECURSE SRCS
    "../src/*.h"
    "../src/*.cpp"
)

file(GLOB_RECURSE TEST_FILES "./*.h" "./*.cpp")

include_directories(
    "../include"
    "../src/dbus"
)

add_definitions(-DUSE_FAKE_INTERFACE)

add_executable(${BIN_NAME}
    ${INCLUDE_FILES}
    ${SRCS}
    ${TEST_FILES}
)

target_include_directories(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
    -lpthread
    -lgcov
    -lgtest
    -lcrypt
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage -fno-access-control)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage -fno-access-control)
endif()

enable_testing()
add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== dtklogin/docs/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc CACHE STRING "QCH install location")
set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dde.${CMAKE_PROJECT_NAME}")
set (DOXYGEN_QCH_FILE "${CMAKE_PROJECT_NAME}.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER ${CMAKE_PROJECT_NAME})
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-5/" CACHE STRING "Doxygen tag files")
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
set (DOXYGEN_PREDEFINED
    "\"DLOGIN_BEGIN_NAMESPACE=namespace Dtk {namespace Login {\""
    "\"DLOGIN_END_NAMESPACE=}}\""
    "\"DLOGIN_USE_NAMESPACE=using namespace Dtk::Login;\""
)

doxygen_add_docs (doxygen_dtklogin
    ${CMAKE_CURRENT_SOURCE_DIR}/../include
    ${CMAKE_CURRENT_SOURCE_DIR}/../docs
    ALL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/html/${CMAKE_PROJECT_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== dtklogin/examples/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

include_directories(../include)
file(GLOB_RECURSE SRCS "*.h" "*.cpp")


add_executable(demo
    ${SRCS}
)

target_link_libraries(demo PRIVATE
    ${BIN_NAME}
    Qt${QT_VERSION_MAJOR}::Core
)

=== dtklogin/src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE INCLUDE_FILES "../include/*.h")
file(GLOB_RECURSE SRCS
    "./*.h"
    "./*.cpp"
)

add_library(${BIN_NAME} SHARED
    ${INCLUDE_FILES}
    ${SRCS}
)

set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

target_include_directories(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    ../include
    ./dbus
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
)

install(FILES ${INCLUDE_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BIN_NAME})
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== dtklogin/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME ut-${BIN_NAME})

file(GLOB_RECURSE INCLUDE_FILES "../include/*.h")
file(GLOB_RECURSE SRCS
    "../src/*.h"
    "../src/*.cpp"
    "./resource/res.qrc"
)

file(GLOB_RECURSE TEST_FILES "./*.h" "./*.cpp")

add_compile_definitions(USE_FAKE_INTERFACE)

add_executable(${BIN_NAME}
    ${INCLUDE_FILES}
    ${SRCS}
    ${TEST_FILES})

target_include_directories(${BIN_NAME} PUBLIC
    ../include
    ../src/dbus
    ../src
    ./fakedbus
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt5::Core
    Qt5::DBus
    -lpthread
    -lgcov
    -lgtest
    -lgmock
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()

target_compile_options(${BIN_NAME} PRIVATE -fno-access-control)

enable_testing()
add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== debian/changelog ===
dtksystemsettings (1.0.0-1) unstable; urgency=medium

  * update

 -- Packages Builder <packages@deepin.com>  Mon, 10 Oct 2022 16:05:05 +0800

dtksystemsettings (1.0.0) unstable; urgency=medium

  * Initial release

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 01 Jul 2022 14:29:07 +0800

=== debian/control ===
Source: dtksystemsettings
Section: libdevel
Priority: optional
Maintainer: Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 doxygen,
 qhelpgenerator-qt5 | qttools5-dev-tools,
 qtbase5-dev
Standards-Version: 4.5.0

Package: libdtksystemsettings
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin Tool Kit template library
 libdtksystemsettings is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtksystemsettings-dev
Architecture: any
Depends:${misc:Depends}, libdtksystemsettings( =${binary:Version})
Description: Deepin Tool Kit template devel library
 libdtksystemsettings-dev is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

%:
	dh $@ --parallel
VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')

override_dh_auto_configure:
	dh_auto_configure -- -DVERSION=$(PACK_VER)

## dtksystemsettings 1.0.3

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)

# If do't define version number, specify the version number
set(VERSION "1.0.0" CACHE STRING "define project version")

project(DtkSystemSettings
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtksystemsettings
    DESCRIPTION "dtk library for systemsettings."
    VERSION ${VERSION}
)

set(LIB_NAME dtksystemsettings)
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH}) # Set module path for include() command search

include(DtkUtils) # Include cmake/DtkUtils.cmake
include(GNUInstallDirs) # Specify install dir
include(CMakePackageConfigHelpers)
include(CMakePrintHelpers)

set_install_dir(INCLUDE include/dtk1/DSystemSettings)
set(MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/mkspecs/modules" CACHE STRING "Install directory for qt pri files")
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--as-needed")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/DtkSystemSettings)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose Debug or Release" FORCE)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
    set(BUILD_EXAMPLES ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
endif ()

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core DBus)
find_package(Dtk REQUIRED COMPONENTS Core)

file(GLOB_RECURSE LIB_PUBLIC_HEADERS "${PROJECT_SOURCE_DIR}/include/*") # Get all headers which will be exported

add_subdirectory(src)

set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")
find_package(Doxygen)
if (BUILD_DOCS AND DOXYGEN_FOUND)
    add_subdirectory(docs)
endif()

# example
if (BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

# test
if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

target_link_directories(${LIB_NAME} INTERFACE
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_LIBDIR}>
)

write_basic_package_version_file(
    DtkSystemSettingsConfigVersion.cmake
    VERSION ${VERSION}
    COMPATIBILITY SameMajorVersion
)

configure_package_config_file(misc/DtkSystemSettingsConfig.cmake.in
    DtkSystemSettingsConfig.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DtkSystemSettings
    PATH_VARS CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_LIBDIR
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DtkSystemSettingsConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/DtkSystemSettingsConfigVersion.cmake DESTINATION ${ConfigPackageLocation})

set(PC_REQUIRES "Qt${QT_VERSION_MAJOR}Core Qt${QT_VERSION_MAJOR}DBus dtkcore")
configure_file(misc/dtksystemsettings.pc.in dtksystemsettings.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtksystemsettings.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

set(DTK_MODULE ${LIB_NAME})
set(DTK_DEPS "core dbus dtkcore")
set(DTK_CFG "v2 ltcg")
configure_file(misc/qt_lib_dtksystemsettings.pri.in qt_lib_dtksystemsettings.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtksystemsettings.pri DESTINATION "${MKSPECS_INSTALL_DIR}")

=== docs/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc CACHE STRING "QCH install location")
set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.systemsettings")
set (DOXYGEN_QCH_FILE "${LIB_NAME}.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER ${LIB_NAME})
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-5/" CACHE STRING "Doxygen tag files")
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
set (DOXYGEN_PREDEFINED
    "DACCOUNTS_BEGIN_NAMESPACE=namespace Dtk { namespace Accounts {"
    "DACCOUNTS_END_NAMESPACE=}}"
    "DACCOUNTS_USE_NAMESPACE=using namespace Dtk::Accounts;"
    "DLOGIN_BEGIN_NAMESPACE=namespace Dtk { namespace Login {"
    "DLOGIN_END_NAMESPACE=}}"
    "DLOGIN_USE_NAMESPACE=using namespace Dtk::Login;"
    "DPOWER_BEGIN_NAMESPACE=namespace Dtk { namespace Power {"
    "DPOWER_END_NAMESPACE=}}"
    "DPOWER_USE_NAMESPACE=using namespace Dtk::Power;"
    "DRFMGR_BEGIN_NAMESPACE=namespace Dtk { namespace RfMgr {"
    "DRFMGR_END_NAMESPACE=}}"
    "DRFMGR_USE_NAMESPACE=using namespace Dtk::RfMgr;"
    "DSYSTEMTIME_BEGIN_NAMESPACE=namespace Dtk { namespace SystemTime {"
    "DSYSTEMTIME_END_NAMESPACE=}}"
    "DTIME_USE_NAMESPACE=using namespace Dtk::SystemTime;"
)

doxygen_add_docs (doxygen
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${PROJECT_BINARY_DIR}/docs/html/${LIB_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_library(${LIB_NAME} SHARED
    ${LIB_PUBLIC_HEADERS}
)

target_compile_definitions(${LIB_NAME} PRIVATE "VERSION=${CMAKE_PROJECT_VERSION}")

# Set include directories for target itself and targets in the build tree(i.e. in this project, some other targets) that linked to this target
target_include_directories(${LIB_NAME} PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/accounts>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/login>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/power>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/rfmanager>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/systemtime>
    $<BUILD_INTERFACE:${DtkCore_INCLUDE_DIRS}>
)

# Set include directory only for external targets linked to this target(i.e. downstream user)
target_include_directories(${LIB_NAME} INTERFACE
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

add_subdirectory(accounts)
add_subdirectory(login)
add_subdirectory(power)
add_subdirectory(rfmanager)
add_subdirectory(systemtime)

target_link_libraries(${LIB_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    ${DtkCore_LIBRARIES}
    crypt
)

set_target_properties(${LIB_NAME} PROPERTIES
    EXPORT_NAME SystemSettings
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    PUBLIC_HEADER "${LIB_PUBLIC_HEADERS}"
)

install(TARGETS ${LIB_NAME} EXPORT DtkSystemSettingsTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(EXPORT DtkSystemSettingsTargets
    FILE DtkSystemSettingsTargets.cmake
    NAMESPACE Dtk::
    DESTINATION ${ConfigPackageLocation}
)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(TEST_NAME ut-${LIB_NAME})

add_executable(${TEST_NAME})

file(GLOB_RECURSE TEST_SOURCES
    "./*.h"
    "./*.cpp"
    "./*.qrc"
)

file(GLOB_RECURSE LIB_SOURCES
    "${PROJECT_SOURCE_DIR}/src/*.h"
    "${PROJECT_SOURCE_DIR}/src/*.cpp"
)

find_package(GTest REQUIRED)

target_sources(${TEST_NAME} PRIVATE
    ${LIB_PUBLIC_HEADERS}
    ${LIB_SOURCES}
    ${TEST_SOURCES}
    "main.cpp"
)

file(GLOB DBUS_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/src/*/dbus")
file(GLOB FAKEDBUS_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/tests/*/fakedbus")


target_include_directories(${TEST_NAME} PRIVATE
    ${DBUS_INCLUDE_DIRS}
    ${FAKEDBUS_INCLUDE_DIRS}
)

target_include_directories(${TEST_NAME} PRIVATE
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/include/accounts
    ${PROJECT_SOURCE_DIR}/include/login
    ${PROJECT_SOURCE_DIR}/include/power
    ${PROJECT_SOURCE_DIR}/include/rfmanager
    ${PROJECT_SOURCE_DIR}/include/systemtime
    ${PROJECT_SOURCE_DIR}/src/accounts
    ${PROJECT_SOURCE_DIR}/src/login
    ${PROJECT_SOURCE_DIR}/src/power
    ${PROJECT_SOURCE_DIR}/src/rfmanager
    ${PROJECT_SOURCE_DIR}/src/systemtime
)

target_link_libraries(${TEST_NAME}
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    ${DtkCore_LIBRARIES}
    crypt
    pthread
    gcov
    gtest
    gmock
)

target_compile_definitions(${TEST_NAME} PRIVATE USE_FAKE_INTERFACE)
target_compile_options(${TEST_NAME} PRIVATE -fno-access-control)
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
target_compile_options(${TEST_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
target_compile_options(${TEST_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()

enable_testing()
add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME})

=== examples/accounts/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_executable(accountsdemo
    main.cpp
    demo.h
    demo.cpp
)

target_link_libraries(accountsdemo PRIVATE
    ${LIB_NAME}
)

=== examples/login/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE LOGIN_DEMO_SOURCES "./*.h" "./*.cpp")

add_executable(logindemo
    ${LOGIN_DEMO_SOURCES}
)

target_link_libraries(logindemo PRIVATE
    Qt${QT_VERSION_MAJOR}::Core    
    ${LIB_NAME}
)

=== examples/power/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_executable(kbbacklightdemo
    dkbbacklightdemo.cpp
)

target_link_libraries(kbbacklightdemo PRIVATE
    ${LIB_NAME}
)

add_executable(powerdevicedemo
    dpowerdevicedemo.cpp
)

target_link_libraries(powerdevicedemo PRIVATE
    ${LIB_NAME}
)

add_executable(powersettingsdemo
    dpowersettingsdemo.cpp
)

target_link_libraries(powersettingsdemo PRIVATE
    ${LIB_NAME}
)

=== examples/rfmanager/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_executable(rfdemo
    main.cpp
    demo.h
    demo.cpp
)

target_link_libraries(rfdemo PRIVATE
    ${LIB_NAME}
)

=== src/login/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE LOGIN_HEADERS "./*.h")
file(GLOB_RECURSE LOGIN_SOURCES "./*.h" "./*.cpp")
target_sources(${LIB_NAME} PRIVATE ${LOGIN_SOURCES})
target_include_directories(${LIB_NAME} PRIVATE "./dbus")

=== src/power/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE POWER_HEADERS "./*.h")
file(GLOB_RECURSE POWER_SOURCES "./*.h" "./*.cpp")
target_sources(${LIB_NAME} PRIVATE ${POWER_SOURCES})
target_include_directories(${LIB_NAME} PRIVATE "./dbus")

=== src/rfmanager/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE RFMANAGER_HEADERS "./*.h")
file(GLOB_RECURSE RFMANAGER_SOURCES "./*.h" "./*.cpp")
target_sources(${LIB_NAME} PRIVATE ${RFMANAGER_SOURCES})

=== debian/changelog ===
dtksystemsettings (1.0.3-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 13:23:21 +0800

dtksystemsettings (1.0.3) unstable; urgency=medium

  * Update changelog
  * Add Dexpected support

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 10:58:14 +0800

=== debian/control ===
Source: dtksystemsettings
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 doxygen,
 qhelpgenerator-qt5 | qttools5-dev-tools,
 qtbase5-dev,
 libdtkcore-dev,
 graphviz
Standards-Version: 4.5.0

Package: libdtksystemsettings1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin Tool Kit template library
 libdtksystemsettings is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtksystemsettings-dev
Architecture: any
Depends:${misc:Depends}, libdtksystemsettings1( =${binary:Version})
Description: Deepin Tool Kit template devel library
 libdtksystemsettings-dev is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

%:
	dh $@
PACK_VER = $(shell echo $(DEB_VERSION_UPSTREAM) | awk -F'[+_~-]' '{print $$1}')
# Fix: invalid digit "8" in octal constant. e.g.  u008 ==> 008 ==> 8
BUILD_VER = $(shell echo $(DEB_VERSION_UPSTREAM) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_VERSION=$(BUILD_VER) -DVERSION=$(PACK_VER)

## dtksystemsettings 5.6.20

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)

# If do't define version number, specify the version number
set(DTK_VERSION "5.0.0" CACHE STRING "define project version")

project(DtkSystemSettings
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtksystemsettings
    DESCRIPTION "dtk library for systemsettings."
    VERSION ${DTK_VERSION}
)

if("${PROJECT_VERSION_MAJOR}" STREQUAL "5")
    set(QT_VERSION_MAJOR "5")
    set(DTK_VERSION_MAJOR "5")
elseif("${PROJECT_VERSION_MAJOR}" STREQUAL "6")
    set(QT_VERSION_MAJOR "6")
    set(DTK_VERSION_MAJOR "6")
    set(VERSION_SUFFIX "6")
else()
    message(SEND_ERROR "not support Prject Version ${PROJECT_VERSION}.")
endif()

# Install settings
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()
include(GNUInstallDirs) # Specify install dir
include(CMakePackageConfigHelpers)
include(CMakePrintHelpers)

set(LIB_NAME dtk${VERSION_SUFFIX}systemsettings)
set(DtkSystemSettings Dtk${VERSION_SUFFIX}SystemSettings)
set(DTK_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dtk${DTK_VERSION_MAJOR}/DSystemSettings" CACHE STRING "Include directory headers")
set(MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}" CACHE STRING "Install directory for qt pri files")
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CONFIG_CMAKE_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${DtkSystemSettings}" CACHE STRING "Install dir for cmake config files")

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose Debug or Release" FORCE)
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
    set(BUILD_EXAMPLES ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
endif()

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core DBus)
find_package(Dtk${VERSION_SUFFIX} REQUIRED Core)

file(GLOB_RECURSE LIB_PUBLIC_HEADERS "${PROJECT_SOURCE_DIR}/include/*") # Get all headers which will be exported

add_subdirectory(src)

set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")
find_package(Doxygen)

if(BUILD_DOCS AND DOXYGEN_FOUND)
    add_subdirectory(docs)
endif()

# example
if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

# test
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

target_link_directories(${LIB_NAME} INTERFACE
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_LIBDIR}>
)

write_basic_package_version_file(
    ${DtkSystemSettings}ConfigVersion.cmake
    VERSION ${DTK_VERSION}
    COMPATIBILITY SameMajorVersion
)

configure_package_config_file(misc/DtkSystemSettingsConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/${DtkSystemSettings}Config.cmake
    INSTALL_DESTINATION ${CONFIG_CMAKE_INSTALL_DIR}
    PATH_VARS CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_LIBDIR
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DtkSystemSettings}Config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/${DtkSystemSettings}ConfigVersion.cmake
    DESTINATION ${CONFIG_CMAKE_INSTALL_DIR}
)

GNUInstallDirs_get_absolute_install_dir(DTK_FULL_INCLUDE_INSTALL_DIR DTK_INCLUDE_INSTALL_DIR INCLUDEDIR)
set(PC_REQUIRES "Qt${QT_VERSION_MAJOR}Core Qt${QT_VERSION_MAJOR}DBus dtk${VERSION_SUFFIX}core")
configure_file(misc/dtksystemsettings.pc.in dtk${VERSION_SUFFIX}systemsettings.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtk${VERSION_SUFFIX}systemsettings.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

set(DTK_MODULE ${LIB_NAME})
set(DTK_DEPS "core dbus dtk${VERSION_SUFFIX}core")
set(DTK_CFG "v2 ltcg")
configure_file(misc/qt_lib_dtksystemsettings.pri.in qt_lib_dtk${VERSION_SUFFIX}systemsettings.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtk${VERSION_SUFFIX}systemsettings.pri DESTINATION "${MKSPECS_INSTALL_DIR}")

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -2,21 +2,36 @@
 #
 # SPDX-License-Identifier: LGPL-3.0-or-later
 
-set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc CACHE STRING "QCH install location")
-set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
-set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
-set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
+find_package(Doxygen REQUIRED)
+set(QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt${QT_VERSION_MAJOR}/doc CACHE STRING "QCH install location")
+set(DOXYGEN_GENERATE_HTML YES CACHE STRING "Doxygen HTML output")
+set(DOXYGEN_GENERATE_XML YES CACHE STRING "Doxygen XML output")
+set(DOXYGEN_GENERATE_QHP YES CACHE STRING "Doxygen QHP output")
 set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
 set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
 set (DOXYGEN_EXTRACT_STATIC YES)
 set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
-set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
-set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
+
+if("${QT_VERSION_MAJOR}" STREQUAL "5")
+    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Help)
+else()
+    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS ToolsTools)
+endif()
+
+get_target_property(_qhelpgenerator_location Qt${QT_VERSION_MAJOR}::qhelpgenerator IMPORTED_LOCATION)
+
+if("${_qhelpgenerator_location}" STREQUAL "")
+    set(_qhelpgenerator_location "qhelpgenerator")
+endif()
+
+set(DOXYGEN_QHG_LOCATION ${_qhelpgenerator_location} CACHE STRING "Doxygen QHG path")
+
+set(DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
 set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.systemsettings")
 set (DOXYGEN_QCH_FILE "${LIB_NAME}.qch")
 set (DOXYGEN_QHP_VIRTUAL_FOLDER ${LIB_NAME})
 set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
-set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-5/" CACHE STRING "Doxygen tag files")
+set(DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-${QT_VERSION_MAJOR}/" CACHE STRING "Doxygen tag files")
 set (DOXYGEN_MACRO_EXPANSION "YES")
 set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
 set (DOXYGEN_PREDEFINED

=== examples/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_subdirectory(accounts)
add_subdirectory(login)
add_subdirectory(power)
add_subdirectory(rfmanager)
add_subdirectory(systemtime)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 # Set include directory only for external targets linked to this target(i.e. downstream user)
 target_include_directories(${LIB_NAME} INTERFACE
-    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+    $<INSTALL_INTERFACE:${DTK_INCLUDE_INSTALL_DIR}>
 )
 
 add_subdirectory(accounts)
@@ -44,13 +44,13 @@
     PUBLIC_HEADER "${LIB_PUBLIC_HEADERS}"
 )
 
-install(TARGETS ${LIB_NAME} EXPORT DtkSystemSettingsTargets
+install(TARGETS ${LIB_NAME} EXPORT ${DtkSystemSettings}Targets
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
+    PUBLIC_HEADER DESTINATION ${DTK_INCLUDE_INSTALL_DIR}
 )
 
-install(EXPORT DtkSystemSettingsTargets
-    FILE DtkSystemSettingsTargets.cmake
-    NAMESPACE Dtk::
-    DESTINATION ${ConfigPackageLocation}
+install(EXPORT ${DtkSystemSettings}Targets
+    FILE ${DtkSystemSettings}Targets.cmake
+    NAMESPACE Dtk${VERSION_SUFFIX}::
+    DESTINATION ${CONFIG_CMAKE_INSTALL_DIR}
 )

=== examples/systemtime/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_executable(systemtimedemo
    dsystemtimedemo.cpp
)

target_link_libraries(systemtimedemo PRIVATE
    ${LIB_NAME}
)

=== src/accounts/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE ACCOUNTS_HEADERS "./*.h")
file(GLOB_RECURSE ACCOUNTS_SOURCES "./*.h" "./*.cpp")
target_sources(${LIB_NAME} PRIVATE ${ACCOUNTS_SOURCES})
target_include_directories(${LIB_NAME} PRIVATE "./dbus")

=== src/systemtime/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE SYSTEMTIME_HEADERS "./*.h")
file(GLOB_RECURSE SYSTEMTIME_SOURCES "./*.h" "./*.cpp")
target_sources(${LIB_NAME} PRIVATE ${SYSTEMTIME_SOURCES})
target_include_directories(${LIB_NAME} PRIVATE "./dbus")

=== debian/changelog ===
dtksystemsettings (5.6.20) unstable; urgency=medium

  * release 5.6.20

 -- YuMing He <heyuming@deepin.org>  Mon, 25 Dec 2023 10:51:31 +0800

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,15 @@
  debhelper-compat (= 12),
  cmake,
  doxygen,
- qhelpgenerator-qt5 | qttools5-dev-tools,
+ qhelpgenerator-qt5,
+ qttools5-dev,
  qtbase5-dev,
  libdtkcore-dev,
+ libdtkcommon-dev,
  graphviz
 Standards-Version: 4.5.0
 
-Package: libdtksystemsettings1
+Package: libdtksystemsettings5
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Deepin Tool Kit template library
@@ -22,7 +24,7 @@
 
 Package: libdtksystemsettings-dev
 Architecture: any
-Depends:${misc:Depends}, libdtksystemsettings1( =${binary:Version})
+Depends:${misc:Depends}, libdtksystemsettings5( =${binary:Version})
 Description: Deepin Tool Kit template devel library
  libdtksystemsettings-dev is base devel library of Deepin Qt/C++ applications.
  .

=== debian/rules ===
--- 
+++ 
@@ -9,4 +9,4 @@
 BUILD_VER = $(shell echo $(DEB_VERSION_UPSTREAM) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DBUILD_VERSION=$(BUILD_VER) -DVERSION=$(PACK_VER)
+	dh_auto_configure -- -DBUILD_VERSION=$(BUILD_VER) -DDTK_VERSION=$(PACK_VER)
